Column: A Sample Column
It's about something exciting
by Marc Zeedar

At a Glance
XD#: 00000
Target Reader: Beginner
Source Code: Yes
Supported Platforms: Mac OS X
About the Author: Marc taught himself programming in high school when he bought his first computer but had no money for software. He's had fun learning ever since.


Let's say you start four threads so that four downloads can happen simultaneously. That's great, but keep in mind that you have no control over how fast each download occurs -- this depends on the internet connection, available bandwidth, the server, and so on -- so the threads could finish in any order.

This means you don't know which download will finish first. If you're taking the downloaded files and displaying progress and/or results to the user, and perhaps storing the downloaded items into a database or data structure within your program, you cannot rely on the files arriving in a particular order.


### A Few More Methods
Within `Window1`, I needed to add a few utility methods. For example, here's a method that erases the "output" folder when we start a new file demo:

	Public Sub eraseOutput()
		var f as new folderItem("output")
		if f <> nil and f.exists then
			f.removeFolderAndContents
		end if
	End Sub

Similarly, I needed a way to guarantee that the filenames generated were unique. To do that, I created a `Dictionary` object, `fileNames`, and stored each used name there. When I'm creating a new name, I do so in a loop until the new name hasn't been used.

We first initialize our canvases. Note that we don't reset `labInfo.Text` if we're in `fileMode`. We set `jobCount` to `0` and start a new `CooperativeThread`. Finally, we start `threadTimer1`.

	Sub Action() Handles Action
		cvConverted.thePict = nil
		cvConverted.refresh(true)
		
		if not fileMode then
			labInfo.text = "Status"
			startTime = system.ticks
		end if
		
		splitPic(cvOriginal.thePict)
		
		jobCount = 0
		redim threadList(-1)
		for i as integer = 0 to (kDivideCount - 1)
			var th as new grayThreadClass
			th.type = thread.types.preemptive
			th.picIndex = i
			threadList.add th
			th.start
		next i
		
		threadTimer1.runMode = timer.runModes.multiple
	End Sub

Since our "file" demos just push the buttons of the first two demos, their code is mostly just initializing variables for those tests. Here's `pbConvert3` (which is the preemptive thread test):

	Sub Action() Handles Action
		eraseOutput
		fileNames = new dictionary
		fileMode = true
		count = 0
		startTime = system.ticks
		
		pbConvert2.press
	End Sub

And `pbConvert4` (cooperative thread test):

	Sub Action() Handles Action
		eraseOutput
		fileNames = new dictionary
		fileMode = true
		count = 0
		startTime = system.ticks
		
		pbConvert.press
	End Sub

Both of these erase the output folder, reset `fileNames` and `count`, turn on `fileMode`, and store the starting time. Then they each push the button of their respective test.



![Figure 1: ](graphics/figure1.jpg)

![Figure 2: ](graphics/figure2.jpg)

![Figure 3: ](graphics/figure3.jpg)

![Figure 4: ](graphics/figure4.jpg)

![Figure 5: ](graphics/figure5.jpg)

![Figure 6: ](graphics/figure6.jpg)

![Figure 7: ](graphics/figure7.jpg)

![Figure 8: ](graphics/figure8.jpg)

![Figure 9: ](graphics/figure9.jpg)

![Figure 10: ](graphics/figure10.jpg)

![Figure 11: ](graphics/figure11.jpg)

![Figure 12: ](graphics/figure12.jpg)